package sun.dc.pr;

import java.security.AccessController;
import java.security.PrivilegedAction;
import sun.dc.path.FastPathProducer;
import sun.dc.path.PathException;
import sun.dc.path.PathError;
import sun.dc.path.PathConsumer;

public class PathDasher implements PathConsumer
{
    private PathConsumer dest;
    private static final float TOP_MAX_MIN_RATIO = 100.0f;
    private long cData;
    
    public PathDasher(PathConsumer dest) {
        if (dest == null) {
            throw new InternalError("null dest for path");
        }
        this.cInitialize(this.dest = dest);
        this.reset();
        return;
    }
    
    public native void dispose();
    
    protected static void classFinalize() throws Throwable {
        cClassFinalize();
    }
    
    public PathConsumer getConsumer() {
        return this.dest;
    }
    
    public native void setDash(float[] p0, float p1) throws PRError;
    
    public native void setDashT4(float[] p0) throws PRError;
    
    public native void setOutputT6(float[] p0) throws PRError;
    
    public native void setOutputConsumer(PathConsumer p0) throws PRError;
    
    public native void reset();
    
    public native void beginPath() throws PathError;
    
    public native void beginSubpath(float p0, float p1) throws PathError;
    
    public native void appendLine(float p0, float p1) throws PathError;
    
    public native void appendQuadratic(float p0, float p1, float p2, float p3) throws PathError;
    
    public native void appendCubic(float p0, float p1, float p2, float p3, float p4, float p5) throws PathError;
    
    public native void closedSubpath() throws PathError;
    
    public native void endPath() throws PathError, PathException;
    
    public void useProxy(FastPathProducer fastPathProducer) throws PathError, PathException {
        fastPathProducer.sendTo(this);
    }
    
    public native long getCPathConsumer();
    
    private static native void cClassInitialize();
    
    private static native void cClassFinalize();
    
    private native void cInitialize(PathConsumer p0);
    
    static {
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                System.loadLibrary("dcpr");
                return null;
            }
        });
        cClassInitialize();
    }
}
